﻿using UnityEngine;
using System;
using HarmonyLib;
using UnityEngine.UI;
using UnityEngine.SceneManagement;
using HMLLibrary;

public class MoreBananas : Mod
{
    Harmony harmony;
    static Button unloadButton;
    static Button.ButtonClickedEvent eventStore = null;
    static bool started;
    static bool CanUnload
    {
        get { return eventStore == null; }
        set
        {
            if (!value && eventStore == null)
            {
                eventStore = unloadButton.onClick;
                unloadButton.onClick = new Button.ButtonClickedEvent();
                unloadButton.onClick.AddListener(delegate { Debug.LogError("Mod must be unloaded on the main menu"); });
                modInstance.modlistEntry.jsonmodinfo.isModPermanent = true;
                ModManagerPage.RefreshModState(modInstance.modlistEntry);
            }
            else if (value && eventStore != null)
            {
                unloadButton.onClick = eventStore;
                eventStore = null;
                modInstance.modlistEntry.jsonmodinfo.isModPermanent = false;
                ModManagerPage.RefreshModState(modInstance.modlistEntry);
            }
        }
    }
    public void Start()
    {
        started = false;
        unloadButton = modlistEntry.modinfo.unloadBtn.GetComponent<Button>();
        if (SceneManager.GetActiveScene().name != Semih_Network.MenuSceneName)
        {
            unloadButton.onClick.Invoke();
            throw new ModLoadException("Mod must be loaded on the main menu");
        }
        harmony = new Harmony("com.aidanamite.MoreBananas");
        harmony.PatchAll();
        Log("Mod has been loaded!");
        started = true;
    }

    public override void WorldEvent_WorldLoaded()
    {
        CanUnload = false;
    }

    public override void WorldEvent_WorldUnloaded()
    {
        CanUnload = true;
    }

    public void OnModUnload()
    {
        if (!started)
            return;
        harmony.UnpatchAll(harmony.Id);
        Log("Mod has been unloaded!");
    }
}

class ModLoadException : Exception
{
    public ModLoadException(string message) : base(message) { }
}

[HarmonyPatch(typeof(Landmark), "Initialize")]
public class Patch_IslandSpawn
{
    static GameObject plantPrefab = null;
    static int bananaInd = ItemManager.GetItemByName("Seed_Banana").UniqueIndex;
    static GameObject PlantPrefab
    {
        get
        {
            if (plantPrefab == null)
                foreach (Plant plant in Resources.FindObjectsOfTypeAll<Plant>())
                    if (plant.item != null && plant.item.UniqueIndex == bananaInd)
                    {
                        plantPrefab = plant.gameObject;
                        break;
                    }
            return plantPrefab;
        }
    }
    static void Prefix(ref Landmark __instance, bool ___initialized)
    {
        if (!___initialized)
        {
            if (PlantPrefab == null)
            {
                Debug.LogError("Could not find banana plant prefab");
                return;
            }
            foreach (MeshRenderer model in __instance.GetComponentsInChildren<MeshRenderer>())
                if (model.name.Contains("Banana_Bush") || model.name.Contains("Banan_Bush"))
                {
                    GameObject gO = GameObject.Instantiate(PlantPrefab, model.transform.position, model.transform.rotation, model.transform.parent.parent);
                    gO.transform.localScale = model.transform.localScale;
                    gO.name = "MoreBananas_Banana_Bush";
                    GameObject.DestroyImmediate(gO.GetComponent<Plant>());
                    LandmarkItem_PickupItem lmpi = gO.AddComponent<LandmarkItem_PickupItem>();
                    lmpi.localLandmarkPosition = lmpi.transform.localPosition;
                    lmpi.Invoke("OnValidate", 0);
                    NetworkIDManager.AddNetworkID(gO.GetComponent<PickupItem_Networked>());
                    gO.tag = "Untagged";
                    foreach (Collider c in gO.GetComponentsInChildren<Collider>())
                        c.gameObject.tag = "Tree";
                    gO.GetComponent<PickupItem>().canBePickedUp = true;
                    Traverse.Create(gO.GetComponent<HarvestableTree>()).Field("hideOnDepleted").SetValue(true);
                    GameObject.Destroy(model.gameObject);
                }
        }
    }
}